/***********************************************************************
 * This program counts the number of occurrences of each word in a phrase
 * entered by the user from the keyboard.
 ***********************************************************************/
#include<vector>
#include<string>
#include<iostream>
#include<iomanip>
using std::cout; using std::string;
using std::cin; using std::endl;
using std::vector; using std::setw;
typedef vector<string>::size_type vecsize;
typedef string::size_type wordsize;

int main()
{
	string word;

	/* Create 'words_so_far', the vector of the distinct words read.
	 * Create 'counts. 'counts[i]' holds the number of occurrences 
	 * of the string in 'words_so_far[i]'.
	 */
	vector<string> words_so_far;
	vector<int> counts;
	bool found;
	wordsize max_length=0;//This holds the length of the longest word.
			      //It is used to display the output neatly.
	
	cout<<"\nPlease enter your words, followed by <ENTER> <CTRL>-D: ";
	
	/* Read in a word until encountering an EOF marker. */
	
// Loop invariant: 'words_so_far' holds the distinct words read from the
// input to this point. 'counts[i]' holds the number of occurrences 
// of the string in 'words_so_far[i]' read to this point. 'max_length' holds 
// the length of the longest word read to this point. 
	while(cin>>word)
	{
		found=false;
		vecsize i=0;
		/* Look through the vector of words for the word just read. 
	 	* If found, increment the corresponding value in the vector of
	 	* counts.
	 	*/
		while(!(found) && (i<words_so_far.size()))
		{
			if(word==words_so_far[i])
			{
				counts[i]++;
				found=true;
			}
			i++;
		}
		/* If the word is not already in the vector, push it 
		 * back, and push back a count of '1' in the counts vector.
		 * Update the length of the longest word read.
		 */
		if(!found)
		{
			words_so_far.push_back(word);
			counts.push_back(1);
			if(word.size()>max_length)
				max_length=word.size();
		}
	}

	/* Display the words and their corresponding counts. Put the words in
	 * a column just wide enough to hold the longest word.
	 */
	if(words_so_far.size()==0)
		cout<<"\nYou chose not to enter any words.\n";
	else
	{
		cout<<"\nHere are the words you entered, with their counts:\n";
		for(vecsize j=0; j!=words_so_far.size();j++)
			cout<<setw(max_length)<<words_so_far[j]<<
				": "<<counts[j]<<endl;
	}
	return 0;
}
		

